#

API Docs for: 2.0.0
Show: Inherited Protected Private Deprecated

# File: src/pixi/geom/Polygon.js

    /**
     * @author Adrien Brault <adrien.brault@gmail.com>
     */

    /**
     * @class Polygon
     * @constructor
     * @param points* {Array<Point>|Array<Number>|Point...|Number...} This can be an array of Points that form the polygon,
     *      a flat array of numbers that will be interpreted as [x,y, x,y, ...], or the arguments passed can be
     *      all the points of the polygon e.g. `new PIXI.Polygon(new PIXI.Point(), new PIXI.Point(), ...)`, or the
     *      arguments passed can be flat x,y values e.g. `new PIXI.Polygon(x,y, x,y, x,y, ...)` where `x` and `y` are
     *      Numbers.
     */
    PIXI.Polygon = function(points)
    {
        //if points isn't an array, use arguments as the array
        if(!(points instanceof Array))points = Array.prototype.slice.call(arguments);

        //if this is a flat array of numbers, convert it to points
        if(points[0] instanceof PIXI.Point)
        {
            var p = [];
            for(var i = 0, il = points.length; i < il; i++)
            {
                p.push(points[i].x, points[i].y);
            }

            points = p;
        }

        this.closed = true;
        this.points = points;
    };

    /**
     * Creates a clone of this polygon
     *
     * @method clone
     * @return {Polygon} a copy of the polygon
     */
    PIXI.Polygon.prototype.clone = function()
    {
        var points = this.points.slice();
        return new PIXI.Polygon(points);
    };

    /**
     * Checks whether the x and y coordinates passed to this function are contained within this polygon
     *
     * @method contains
     * @param x {Number} The X coordinate of the point to test
     * @param y {Number} The Y coordinate of the point to test
     * @return {Boolean} Whether the x/y coordinates are within this polygon
     */
    PIXI.Polygon.prototype.contains = function(x, y)
    {
        var inside = false;

        // use some raycasting to test hits
        // https://github.com/substack/point-in-polygon/blob/master/index.js
        var length = this.points.length / 2;

        for(var i = 0, j = length - 1; i < length; j = i++)
        {
            var xi = this.points[i * 2], yi = this.points[i * 2 + 1],
                xj = this.points[j * 2], yj = this.points[j * 2 + 1],
                intersect = ((yi > y) !== (yj > y)) && (x < (xj - xi) * (y - yi) / (yj - yi) + xi);

            if(intersect) inside = !inside;
        }

        return inside;
    };

    // constructor
    PIXI.Polygon.prototype.constructor = PIXI.Polygon;